//+------------------------------------------------------------------+
//|                                            ind_SmirnoffMA_v1.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "*"
#property link      "*"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
//---- input parameters
extern int m=4,m_=2;
//---- buffers
double ExtMapBuffer1[];

double q1[],q2[],alf;
int j,n,s;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   alf=2.0/(m_+1);
   n=m-1;
   ArrayResize(q1,n+1);
   ArrayResize(q2,n+1);   
   
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){


         int limit=Bars-IndicatorCounted();
            for(int i=limit-1;i>=0;i--){
               q1[0]=Close[i];
               
                  for(j=1;j<=n;j++){
                     q1[j]=q1[j-1]+alf*(Close[i+j]-q1[j-1]);
                  }
                  for(s=1;s<=m/2-1;s++){
                        for(j=0;j<=n;j++){
                           q2[j]=q1[n-j];
                        }
                     q1[0]=q2[0];
                        for(j=1;j<=n;j++){
                           q1[j]=q1[j-1]+alf*(q2[j]-q1[j-1]);
                        }
                  }
               ExtMapBuffer1[i]=q1[n];                  
            }


   return(0);
}
//+------------------------------------------------------------------+